/*
 * FW[
 * 
 * EAPI`wb_t@C
 *
 */
#ifndef MW_ASR_ASR_H_
#define MW_ASR_ASR_H_



/******************************************************************
                        include t@C
*******************************************************************/
#include <nn/types.h>

/******************************************************************
            萔^^`
*******************************************************************/
// GW萔
#define ASR_MAX_WORD_LENGTH             32
#define ASR_MAX_SENTENCE_LENGTH        128
#define ASR_MAX_CANDIDATES              10
#define ASR_MAX_DICT_SIZE              100
#define ASR_MAX_VOICEON_TIMEOUT      10000
#define ASR_MAX_VOICEOFF_TIMEOUT     10000
#define ASR_DEFAULT_VOICEON_TIMEOUT   1000
#define ASR_DEFAULT_VOICEOFF_TIMEOUT  1000
#define ASR_DEFAULT_EPD_INTERVAL       350
/* 臒l */
#define ASR_MAX_THRESHOLD        128
#define ASR_DEFAULT_THRESHOLD    60

/* AutoScale@\ */
#define ASR_AUTOSCALE_ON      1  /* AutoScaleLݒ */
#define ASR_AUTOSCALE_OFF     0  /* AutoScaleݒ */
#define ASR_DEFAULT_AUTOSCALE ASR_AUTOSCALE_ON

#define ASR_DEFAULT_THREAD_PRIORITY      8

// FtO
#define ASR_RECOG_STARTED       0x80

/* G[ԍ */
// CORE,MW
#define ASR_NO_ERROR                 0
#define ASR_ERROR_CORE             (-1)
#define ASR_ERROR_PARAM            (ASR_ERROR_CORE)
#define ASR_ERROR_INTERNAL         (ASR_ERROR_CORE -1)
#define ASR_ERROR_DIC_TOO_LARGE    (ASR_ERROR_CORE -2)
#define ASR_ERROR_DIC_LONG_SPEL    (ASR_ERROR_CORE -3)
#define ASR_ERROR_DIC_MISSPEL      (ASR_ERROR_CORE -4)
#define ASR_ERROR_DIC_CONV         (ASR_ERROR_CORE -5)
#define ASR_ERROR_OFFTIMEOUT       (ASR_ERROR_CORE -6)
#define ASR_ERROR_ONTIMEOUT        (ASR_ERROR_CORE -7)
#define ASR_ERROR_TOO_LOUD         (ASR_ERROR_CORE -8)
#define ASR_ERROR_TOO_SOON         (ASR_ERROR_CORE -9)


// I[o
#define ASR_MIN_EPD_INTERVAL   100
#define ASR_MAX_EPD_INTERVAL   1000

#define ASR_DATA_ITEM_NUM 6

#define D_ENUM_INT 0x7FFFFFFF // enumintŒ`邽߂̒l

#ifdef __cplusplus
namespace mw{
namespace asr{

/* Fݒ */
typedef enum {
    LANG_JAPANESE = 0x1,        // {
    LANG_BRITISH,               // pp
    LANG_US_ENGLISH,            // čp
    LANG_FRENCH,                // tX
    LANG_SPANISH,               // XyC
    LANG_GERMAN,                // hCc
    LANG_ITALIAN,               // C^A
    LANG_DUTCH,                 // I_
    LANG_CHINESE,               // 
    LANG_KOREAN,                // ؍
    LANG_RUSSIAN,               // VA
    LANG_CA_FRENCH,             // JifBAt`
    LANG_MEX_SPANISH            // LVJpjbV
} LangType;

/* ˑf[^ */
typedef enum {
    DTB_DATA_TYPE = 0x1,
    HMM_DATA_TYPE,
    TREE_DATA_TYPE,
    PHN_DATA_TYPE,
    MDC_DATA_TYPE,
    STORAGE_DATA_TYPE,
    DATA_TYPE_MAX = D_ENUM_INT
} DataType;

typedef struct _DataItemType{
    DataType    type;
    void        *data;
    s32         size;
}DataItemType;

/* p[^ݒp\ */
typedef struct _ParamType {
    s16    maxCandidate;    // max number of candidates (1`10)
    s16    offTimeout;      // timeout value for silence (0`10000[X10ms])
    s16    onTimeout;       // timeout value for continuos speech (0`10000[X10ms])
    s16    epdInterval;     // EPD interval (100`1000[ms])
    s16    voiceThreshold;  // Voice switch threshold (60`)
    s16    autoScale;       // Auto Scale ( ASR_AUTOSCALE_ON or ASR_AUTOSCALE_OFF )
} ParamType;

/******************************************************************
 (1) RAGWAPI`
 ******************************************************************/
s32 GetWorkMemSize(void);
s16 RecogInit(LangType language, DataItemType *data, s16 itemCount, s16 *workMem);
s16 RecogEnd(void *data);
s16 SetDict(u8 *dict, s16 word_count);
s16 SetParam(ParamType *param);
s16 GetParam(ParamType *param);
s16 RecogStart(void);
s16 RecogFrame(s16 *framePtr, u16 frameSize);
s16 GetCandidateWord(s16 order);
s16 GetCandidateScore(s16 order);
} // namespace mw
} // namespace asr
#endif /* #ifdef __cplusplus */

// ȉ CI/Fp
#ifdef __cplusplus
extern "C" {
#endif /* #ifdef __cplusplus */

/* Fݒ */
typedef enum {
    MWASR_LANG_JAPANESE = 0x1,        // {
    MWASR_LANG_BRITISH,               // pp
    MWASR_LANG_US_ENGLISH,            // čp
    MWASR_LANG_FRENCH,                // tX
    MWASR_LANG_SPANISH,               // XyC
    MWASR_LANG_GERMAN,                // hCc
    MWASR_LANG_ITALIAN,               // C^A
    MWASR_LANG_DUTCH,                 // I_
    MWASR_LANG_CHINESE,               // 
    MWASR_LANG_KOREAN,                // ؍
    MWASR_LANG_RUSSIAN,               // VA
    MWASR_LANG_CA_FRENCH,             // JifBAt`
    MWASR_LANG_MEX_SPANISH            // LVJXpjbV
} mwasrLangType;

/* ˑf[^ */
typedef enum {
    MWASR_DTB_DATA_TYPE = 0x1,
    MWASR_HMM_DATA_TYPE,
    MWASR_TREE_DATA_TYPE,
    MWASR_PHN_DATA_TYPE,
    MWASR_MDC_DATA_TYPE,
    MWASR_STORAGE_DATA_TYPE,
    MWASR_DATA_TYPE_MAX = D_ENUM_INT
} mwasrDataType;

typedef struct _mwasrDataItemType {
    mwasrDataType     type;
    void              *data;
    s32               size;
} mwasrDataItemType;

/* p[^ݒp\ */
typedef struct _mwasrParamType {
    s16    maxCandidate;    // max number of candidates (1`10)
    s16    offTimeout;      // timeout value for silence (0`10000[X10ms])
    s16    onTimeout;       // timeout value for continuos speech (0`10000[X10ms])
    s16    epdInterval;     // EPD interval (100`1000[ms])
    s16    voiceThreshold;  // Voice switch threshold (60`)
    s16    autoScale;       // Auto Scale ( ASR_AUTOSCALE_ON or ASR_AUTOSCALE_OFF )
} mwasrParamType;

/* OAPI */
s32 mwasrGetWorkMemSize(void);
s16 mwasrRecogInit(mwasrLangType language, mwasrDataItemType *data, s16 itemCount, s16 *workMem);
s16 mwasrRecogEnd(void *data);
s16 mwasrSetDict(u8 *dict, s16 word_count);
s16 mwasrSetParam(mwasrParamType *param);
s16 mwasrGetParam(mwasrParamType *param);
s16 mwasrRecogStart(void);
s16 mwasrRecogFrame(s16 *framePtr, u16 frameSize);
s16 mwasrGetCandidateWord(s16 order);
s16 mwasrGetCandidateScore(s16 order);

#ifdef __cplusplus
}
#endif /* #ifdef __cplusplus */

#endif // MW_ASR_ASR_H_
