/*-----------------------------------------------------------------------*
 Project: [ASR Sample]
 File: [demo.cpp]

 Copyright (C) 2010 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/

#include <nn.h>
#include <nn/os.h>
#include <nn/fs.h>
#include <nn/fnd.h>
#include <nn/hid.h>
#include <nn/applet.h>
#include "asr_sample.h"



/*!--------------------------------------------------------*
 @brief  : DemoMain()
 @param  : Ȃ
 @return : Ȃ
 @summary: fAvC
*----------------------------------------------------------*/
void DemoMain( int eventFlag )
{
    int langCnt=0;
    int modelCnt=0;


    PRINT_OUT("Demo Start\n");

    while(1){
        PRINT_OUT("\n/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/\n\n");
        PRINT_OUT("  [A]     Recog Start\n");
        PRINT_OUT("  []    Next Language\n");
        PRINT_OUT("  []    Prev Language\n");
        PRINT_OUT("  [->]    Next Model\n");
        PRINT_OUT("  [<-]    Prev Model\n");
        PRINT_OUT("  [START] Exit\n");

        PRINT_OUT("\n\n"); 

        switch( GET_KEY_EVENT( eventFlag ) ){
        // [A] ꂽ
        case D_BUTTON_A:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[A]     Pushed :Recog Start\n");
            PRINT_OUT("=============================================\n");
            PRINT_OUT(" [setLang=%s\t model=%s]\n", getLangName(langCnt),getModelName(modelCnt));
            asr_test(langCnt,modelCnt);
            break;

        // [] ꂽ
        case D_BUTTON_UP:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[UP]    Pushed :Next Language\n");
            PRINT_OUT("=============================================\n");
            if( langCnt < D_LANG_COUNT_MAX -1){
                langCnt++;
            }else{
                langCnt=0;
            }
			// ꂪ؂ւmodelmixedLargeǂݍނ悤ɂ
            modelCnt=0;
            PRINT_OUT(" [setLang=%s\t model=%s]\n", getLangName(langCnt),getModelName(modelCnt));
            break;
        // [] ꂽ
        case D_BUTTON_DOWN:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[DOWN]  Pushed :Prev Language\n");
            PRINT_OUT("=============================================\n");
            if( langCnt == 0 ){
                langCnt = D_LANG_COUNT_MAX -1;
            }else{
                langCnt--;
            }    
			// ꂪ؂ւmodelmixedLargeǂݍނ悤ɂ
            modelCnt=0;
            PRINT_OUT(" [setLang=%s\t model=%s]\n", getLangName(langCnt),getModelName(modelCnt));
            break;

        // [<-] ꂽ
        case D_BUTTON_LEFT:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[LEFT]  Pushed :Prev Model\n");
            PRINT_OUT("=============================================\n");
                    
            if( modelCnt == 0 ){
                modelCnt = getModelNumMax(langCnt) -1;
            }else{
                modelCnt--;
            }
            PRINT_OUT(" [setLang=%s\t model=%s]\n", getLangName(langCnt),getModelName(modelCnt));
            break;

        // [->] ꂽ
        case D_BUTTON_RIGHT:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[RIGHT] Pushed :Next Model\n");
            PRINT_OUT("=============================================\n");

            if( modelCnt < getModelNumMax(langCnt)-1 ){
                modelCnt++;
            }else{
                modelCnt=0;
            }
            PRINT_OUT(" [setLang=%s\t model=%s]\n", getLangName(langCnt),getModelName(modelCnt));
            break;

        // [ViI EOF]
        case D_BUTTON_SINARIO_EOF:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[Scenario File End]\n");
            PRINT_OUT("=============================================\n");
            goto FINISH;

        default:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[!!!!]   Pushed :Invalid Key !!\n");
            PRINT_OUT("=============================================\n");
            break;

        }
    }

FINISH:
	return;
}


void AppCommonInit(void)
{
    nn::Result result;

    // fs ̏
    nn::fs::Initialize();

    // hid ̏
    result = nn::hid::Initialize();

    // z[j[sł悤 nn::applet::Enable() ̂݌Ă
    // z[j[Jڂd{^NbNAX[vɂ͔Ή
    nn::applet::Enable();
}

void AppCommonEnd(void)
{
    nn::hid::Finalize();
}

/*!--------------------------------------------------------*
 @brief  : nnMain()
 @param  : Ȃ
 @return : Ȃ
 @summary: fAvC
*----------------------------------------------------------*/
void nnMain()
{

    PRINT_OUT2("Demo Start\n");

	AppCommonInit();

    OS_MEM_INIT();

    PRINT_OUT2("MEM_INIT OK\n");

    FILE_IO_INIT();
    PRINT_OUT2("FIL_IO_INIT OK\n");

#ifdef ENABLE_TIMESCALE
    OS_TICK_INIT();
    PRINT_OUT("OS_TICK_INIT OK\n");
#endif /* #ifdef ENABLE_TIMESCALE */

    PRINT_OUT("Demo Start\n");

    UTILITY_INIT( SCENARIO_FILE );

    /////////////////////////////////////////////////
    // s[h̑I
    /////////////////////////////////////////////////
    while(1){
        PRINT_OUT("\n/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/\n\n");
       
        // 
        PRINT_OUT("  [A]     Use Controller\n");
        PRINT_OUT("  [B]     Use Scenario File\n");
        PRINT_OUT("  [START] Application Exit\n");
        PRINT_OUT("\n\n");
    
        PRINT_OUT(" \n");
        PRINT_OUT(" Input KEY = ?\n");
        PRINT_OUT(" \n");

        switch( GET_KEY_EVENT( D_USE_KEYEVENT ) ){
        // [A] ꂽ
        case D_BUTTON_A:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[A]     Pushed :Use Controller\n");
            PRINT_OUT("=============================================\n");
            DemoMain(D_USE_KEYEVENT);
            break;

        // [X] ꂽ
        case D_BUTTON_B:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[B]     Pushed :Use Scenario File\n");
            PRINT_OUT("=============================================\n");
            DemoMain(D_USE_SINARIO);
            break;

        // [START]  ꂽ
        case D_BUTTON_START:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[START]  Pushed :Application Exit\n");
            PRINT_OUT("=============================================\n");
            PRINT_OUT( " Finish!!\n");
            goto FINISH;
        default:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[!!!!]   Pushed :Invalid Key !!\n");
            PRINT_OUT("=============================================\n");
            break;
        }
    
    }


FINISH:
    UTILITY_TERM();
    FILE_IO_TERM();

    OS_MEM_TERM();
    AppCommonEnd();

    PRINT_OUT2("*** End of test ***\n");
    PRINT_OUT2("Demo End\n");


}
