/*-----------------------------------------------------------------------*
 Project: [ASR GuiSample]
 File: [asr_font.h]

 Copyright (C) 2010 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/
#ifndef _ASR_FONT_H_
#define _ASR_FONT_H_

#ifdef __cplusplus
//extern "C" {
#endif


/******************************************************************
                        include t@C
*******************************************************************/
#include <nn/types.h>
#include <nn/os.h>
#include <nn/font.h>
using namespace nn::os;
using namespace nn::font;

/******************************************************************
            OJ֐
*******************************************************************/
void* InitShaders(nn::font::RectDrawer* pDrawer);
void InitDraw( int width, int height );
bool InitFont( nn::font::ResFont*  pFont, const wchar_t*  filePath );
void CleanupFont(nn::font::ResFont* pFont);
nn::font::DispStringBuffer* AllocDispStringBuffer(int charMax);
void SetupTextCamera( nn::font::RectDrawer* pDrawer, int width, int height );
void DrawTextWithFontLong( nn::font::RectDrawer* pDrawer, nn::font::DispStringBuffer* pDrawStringBuf,
    nn::font::ResFont* pFont, char pStrList[10][128], int nu, int width, int height );
void DrawLevelMeter( nn::font::RectDrawer* pDrawer, nn::font::DispStringBuffer* pDrawStringBuf, nn::font::ResFont* pFont, int level );
void DrawTextWithFont( nn::font::RectDrawer* pDrawer, nn::font::DispStringBuffer* pDrawStringBuf,nn::font::ResFont* pFont,
    char* pString, int width, int height );
void DrawText( nn::font::RectDrawer* pDrawer, nn::font::DispStringBuffer* pDrawStringBuf, nn::font::ResFont* pFont,
    char* pString, int x, int y, int width, int height );

#ifdef __cplusplus
//}
#endif
#endif /* #ifndef _ASR_FONT_H_ */
