/*-----------------------------------------------------------------------*
 Project: [ASR GuiSample]
 File: [asr_mic.h]

 Copyright (C) 2010 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/

#ifndef _ASR_MIC_H_
#define _ASR_MIC_H_

#include <nn/os.h>
#include <nn/types.h>

class MicDemo
{
public:
    virtual void Initialize(void* aMicBuffer, int aBufferSize, bool* aSleepTime );
    virtual void Finalize(void);

    virtual void Start(void);
    virtual void Stop(void);

    void GetMicData(s16** pDest, u32 *pSize);
    s16 ReadBuffer( s16 *pFrame );

public:
    static const int MIC_BUFFER_SIZE   = 128*100*60*2; /* 1 */

private:
    static const u8  MIC_GAIN          = 43;
    static const int FRAME_SIZE        = 128;
    
    size_t m_SamplingLength;
    u8 m_MicGain;
    bool m_AmpStatus;
    NN_PADDING2;
    s16* ASR_ReadStart;
    int  m_micLoop;
    uptr m_lastSampAddress;
    nn::os::Mutex m_mutex;
    s16* m_MicBuffer;
};

#endif /* #ifndef _ASR_MIC_H_ */

