/*-----------------------------------------------------------------------*
 Project: [ASR GuiSample]
 File: [libASRMW.h]

 Copyright (C) 2010 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/
#ifndef _LIBASRMW_H_
#define _LIBASRMW_H_

#ifdef __cplusplus
extern "C" {
#endif


/******************************************************************
                        include t@C
*******************************************************************/
#include <nn/types.h>
#include "asr.h"

using namespace mw::asr;
/******************************************************************
            萔^^`
*******************************************************************/
#define ASR_CANDI_NUM                   10
#define ASR_DEFAULT_THREAD_PRIORITY     8
#define ASR_ERROR_MW         (-0x80)
#define ASR_ERROR_MIC        (ASR_ERROR_MW -1)

/* }CNTvOp萔 */
#define ASR_MIC_GAIN PM_AMPGAIN_80
#define ASR_MIC_BUFFER_SIZE 25600
#define ASR_FRAME_TIME 12
#define ASR_FRAME_SIZE 128

typedef struct _ASRResultType {
    s16 result;                    // F(1ȏFE␔A̒lFG[R[h)
    s16 candiNum[ASR_CANDI_NUM];   // Fԍz
    s16 candiScore[ASR_CANDI_NUM]; // F]lz
} ASRResultType;

/* R[obN֐` */
typedef enum {
    ASR_RESULT_MICINIT_COMPLETED = 0x01,
    ASR_RESULT_RECOG_COMPLETED,
    ASR_RESULT_RECOG_FAILED,
    ASR_RESULT_RECOG_STARTED,
    ASR_RESULT_VOICE_LEVEL
} ASRResultCode;

typedef void (* ASRCallback)(ASRResultCode result, void *addr);


s16 ASR_MICInit( void* aMicBuffer, int aBufferSize, ASRCallback aCallback, s16 *aParam );
void ASR_MICInitConfirm( void );
s16 ASR_MICEnd(void);
s16 ASR_MWInit( LangType aLangType, DataItemType *aData, s16 aItemCount, s16 *aMem);
s16 ASR_MWEnd(void *data);
s16 ASR_MWRecogStart(u8 *dict, s16 word_count, ParamType *param, ASRResultType *result, ASRCallback callback);
void ASR_MWRecogStop(void);
void ASR_MWRecogEnd(void);
void ASR_MWSetThreadPriority(u32 prio);
u32  ASR_MWGetThreadPriority(void);


#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* #ifndef _LIBASRMW_H_ */
