/*-----------------------------------------------------------------------*
 Project: [ASR GuiSample]
 File: [demo.cpp]

 Copyright (C) 2010 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/
/******************************************************************
                        include t@C
*******************************************************************/
#include <nn.h>
#include <nn/os.h>
#include <nn/types.h>
#include <nn/fs.h>
#include <nn/fnd.h>
#include <nn/hid.h>
#include <nn/math.h>
#include <nn/hid.h>
#include <nn/applet.h>

#include "CTR_Define.h"
#include "CtrlGraphics.h"
#include "asr.h"
#include "libASRMW.h"
#include "asr_mw.h"
#include "asr_font.h"


/******************************************************************
            namespaceݒ
*******************************************************************/
using namespace nn::hid;
using namespace nn::os;
using namespace nn::math;
using namespace mw::asr;

/******************************************************************
            萔^^`
*******************************************************************/
#define MULTI_DIC_PATH   TEST_DATA_ROOT"dic"
#define MULTI_DATA_PATH  TEST_DATA_ROOT"data/libASR"


/******************************************************************
            O[oϐ̎Q
*******************************************************************/
extern nn::fnd::ExpHeap gAppHeap;

/******************************************************************
            O[oϐ̒`
*******************************************************************/
/** t@CpX */
static char gFilePath[2048]; // TCY傫̂ŃO[oŎ */

/** f[^ */ // TCY傫̂ŃO[oŎ */
static unsigned char gDict[ASR_MAX_DICT_SIZE * (ASR_MAX_SENTENCE_LENGTH + 7) + 4];

/** }CNobt@ */
static s16 gMicBuffer[MicDemo::MIC_BUFFER_SIZE] NN_ATTRIBUTE_ALIGN(nn::mic::BUFFER_ALIGNMENT_ADDRESS);

/** ˑf[^ */
static DataItemType gDataItem[ASR_DATA_ITEM_NUM] ;

static volatile short CallbackFlag; // R[obN󂯂ǂ̃tO
static volatile short GameASRFlag;  // Q[XbhŎQƂtO
static volatile short GameASRError; // Q[XbhŎQƂG[R[h

static char gRecogWord[ASR_MAX_CANDIDATES][ASR_MAX_SENTENCE_LENGTH];
static short gVoiceVal=0;

/******************************************************************
            ֐
*******************************************************************/
/*!--------------------------------------------------------*
 @brief  : Callback()
 @param  : result     R[obN֐
 @return : addr       t
 @summary: R[obN֐
*----------------------------------------------------------*/
static void Callback(ASRResultCode result, void *addr)
{
    ASRResultType *asrResult;
    
    GameASRFlag = (short)result;
    switch (result){
        case ASR_RESULT_MICINIT_COMPLETED:
            GameASRError = *(short *)(addr);
            PRINT_OUT("[Callback] Mic Init Completed\n");
            break;
        /* ȉASR_MWRecogStart()ɐݒ肵Fʊi[obt@Q[XbhŎQƂłȂΕsv */
        case ASR_RESULT_RECOG_COMPLETED:
        case ASR_RESULT_RECOG_FAILED:
            asrResult = (ASRResultType *)addr;
            GameASRError = asrResult->result;
            /* ꍇɂĂ͔Fʂ̃Rs[ */
            PRINT_OUT("[Callback] ret = %d\n", asrResult->result);
            break;
        case ASR_RESULT_RECOG_STARTED:
            GameASRFlag=0;
            PRINT_OUT("[Callback] RECOG STARTED\n");
            break;
        case ASR_RESULT_VOICE_LEVEL:
            GameASRFlag=0;
            gVoiceVal = *(s16*)(addr);
//            PRINT_OUT("%d\n", gVoiceVal);
            break;
        default:
            break;
    }
    CallbackFlag = 1;
}
/*!--------------------------------------------------------*
 @brief  : ASRResultString()
 @param  : id         ID
 @return : I̕
 @summary: wID猾ʂ̕擾
*----------------------------------------------------------*/
static char* ASRResultString( int id )
{
    char* ret;
    switch( id ){
    case ASR_NO_ERROR:
        ret="ASR_NO_ERROR";
        break;
    case ASR_ERROR_PARAM:
        ret="ASR_ERROR_PARAM";
        break;
    case ASR_ERROR_INTERNAL:
        ret="ASR_ERROR_INTERNAL";
        break;
    case ASR_ERROR_DIC_TOO_LARGE:
        ret="ASR_ERROR_DIC_TOO_LARGE";
        break;
    case ASR_ERROR_DIC_LONG_SPEL:
        ret="ASR_ERROR_DIC_LONG_SPEL";
        break;
    case ASR_ERROR_DIC_MISSPEL:
        ret="ASR_ERROR_DIC_MISSPEL";
        break;
    case ASR_ERROR_DIC_CONV:
        ret="ASR_ERROR_DIC_CONV";
        break;
    case ASR_ERROR_OFFTIMEOUT:
        ret="ASR_ERROR_OFFTIMEOUT";
        break;
    case ASR_ERROR_ONTIMEOUT:
        ret="ASR_ERROR_ONTIMEOUT";
        break;
    case ASR_ERROR_TOO_LOUD:
        ret="ASR_ERROR_TOO_LOUD";
        break;
    case ASR_ERROR_TOO_SOON:
        ret="ASR_ERROR_TOO_SOON";
        break;
    default:
        ret="ASR_ERROR_INTERNAL";
        break;
    }
    return ret;
}

// ----------------------------------------------------------------------
// nnMain
// ----------------------------------------------------------------------
void nnMain(void)
{
    int                cnt                = 0;
    int                ret                = 0;
    CCtrlGraphics    graphics;                    // OtBbNNX
    bool g_againFlag = false;

    nn::Result result;
    nn::font::ResFont font;
    nn::font::RectDrawer drawer;

    // ---------------------------------------------------------------------
    // Cu֘A
    // ---------------------------------------------------------------------
    s32 workMemSize;
    s16 *workMem=NULL;
    int dicNum;
    int curLangId = 0;
    LangType lang;
    char str[128];
    int recogNum = 0;
    s16 errCode;
    // ======================================================================

    PRINT_OUT("Demo Start\n");

    // fs ̏
    nn::fs::Initialize();

    // hid ̏
    result = nn::hid::Initialize();
    NN_UTIL_PANIC_IF_FAILED(result);
    
    // z[j[sł悤 nn::applet::Enable() ̂݌Ă
    // z[j[Jڂd{^NbNAX[vɂ͔Ή
    nn::applet::Enable();

    // pbh
    PadReader        padReader;
    PadStatus        padStatus;

    OS_MEM_INIT();
    FILE_IO_INIT();
    OS_TICK_INIT();

     // ----------------------------------------------------------------------
    // OtBbNNX̏
    // ----------------------------------------------------------------------
    graphics.InitializeGraphics();

    // `惊\[X̍\z
    void *const drawerBuf = InitShaders(&drawer);

    // `敶pobt@̊m
    nn::font::DispStringBuffer *const pDrawStringBuf0 = AllocDispStringBuffer(512);
    nn::font::DispStringBuffer *const pDrawStringBuf1 = AllocDispStringBuffer(512);
    nn::font::DispStringBuffer *const pDrawStringBuf2 = AllocDispStringBuffer(512);
    nn::font::DispStringBuffer *const pDrawStringBuf3 = AllocDispStringBuffer(512);

    // ----------------------------------------------------------------------
    // Cu֐FKvƗ̈TCY̎擾
    // ----------------------------------------------------------------------
    workMemSize = GetWorkMemSize() ;
    PRINT_OUT("workMemSize = %d\n", workMemSize) ;
    workMem = (s16 *)OS_MALLOC(workMemSize) ;
    if( workMem <= 0 ){
        PRINT_OUT("[ERROR] workMem <= 0 \n");
        goto FINISH;
    }

    // ----------------------------------------------------------------------
    // tHgݒ
    // ----------------------------------------------------------------------
    // tHg̍\z
    {
#ifndef NN_BUILD_RELEASE
        bool bSuccess =
#endif // NN_BUILD_RELEASE
        InitFont(&font,L"rom:/font/Latin1.bcfnt"); 
        NN_ASSERTMSG(bSuccess, "Fail to load ResFont.");
    }
    
PLAY_AGAIN:

    while(true){
        char buf[256];
        char info[256];

        sprintf( buf, "\n Language [%s]\n\n", getLangName(curLangId));
        // 
        graphics.ClearDisplay(NN_GX_DISPLAY0);
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
        graphics.SetColor(NN_GX_DISPLAY0, 1.0, 0.0, 0.0);            
        InitDraw(NN_GX_DISPLAY0_WIDTH, NN_GX_DISPLAY0_HEIGHT);
        DrawTextWithFont(&drawer, pDrawStringBuf2, &font, buf ,NN_GX_DISPLAY0_WIDTH, NN_GX_DISPLAY0_HEIGHT);
        graphics.SwapBuffer(NN_GX_DISPLAY0);

        // 
        graphics.ClearDisplay(NN_GX_DISPLAY1);
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
        graphics.SetColor(NN_GX_DISPLAY1, 1.0, 0.0, 0.0);            
        InitDraw(NN_GX_DISPLAY1_WIDTH, NN_GX_DISPLAY1_HEIGHT);


        sprintf(info, "%s%s%s%s%s",
            "USEAGE\n",
            "  [L][R]  : Select Language\n",
            "  [A]     : Start Recognition\n",
            "  [B]     : Stop  Recognition\n",
            "  [Start] : App End\n");

            
        DrawText(&drawer, pDrawStringBuf3, &font, info, 15, 100 ,NN_GX_DISPLAY1_WIDTH, NN_GX_DISPLAY1_HEIGHT);

        graphics.SwapBuffer(NN_GX_DISPLAY1);

        padReader.ReadLatest(&padStatus);

        // L Button i}CiXj
        if (padStatus.trigger & BUTTON_L){
            if( curLangId == 0 ){
                curLangId = D_LANG_COUNT_MAX -1;
            }else{
                curLangId--;
            }
            PRINT_OUT(" [Lang=%s\t]\n", getLangName(curLangId));
        }

        // R Button ivXj
        if (padStatus.trigger & BUTTON_R){
            if( curLangId < D_LANG_COUNT_MAX -1){
                curLangId++;
            }else{
                curLangId=0;
            }                    
            PRINT_OUT(" [Lang=%s\t]\n", getLangName(curLangId));
        }

        if (padStatus.trigger & BUTTON_A){
            sprintf(info,"Selected %s .\n\nPlease wait...\n", getLangName(curLangId));
            graphics.ClearDisplay(NN_GX_DISPLAY1);
            glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
            InitDraw(NN_GX_DISPLAY1_WIDTH, NN_GX_DISPLAY1_HEIGHT);
            DrawText(&drawer, pDrawStringBuf3, &font, info, 15, 100 ,NN_GX_DISPLAY1_WIDTH, NN_GX_DISPLAY1_HEIGHT);
            graphics.SwapBuffer(NN_GX_DISPLAY1);
            break;
        }

        if (padStatus.trigger & BUTTON_START){
            PRINT_OUT(" [App End]\n");
            goto FINISH;
        }
        nn::os::Thread::Sleep(nn::fnd::TimeSpan::FromMilliSeconds (D_DELAY_TIME));
        graphics.WaitVsync();
    }


    // ----------------------------------------------------------------------
    // tHgݒ
    // ----------------------------------------------------------------------
    // tHg̍č\z
    {
        wchar_t*  fontPath;
        if( curLangId == 0 ){
            fontPath= L"rom:/font/SJIS.bcfnt";
        }else{
            fontPath= L"rom:/font/Latin1.bcfnt";
        }

        CleanupFont(&font);
#ifndef NN_BUILD_RELEASE
        bool bSuccess =
#endif // NN_BUILD_RELEASE
        InitFont(&font, fontPath);
        NN_ASSERTMSG(bSuccess, "Fail to load ResFont.");
    }

    // ----------------------------------------------------------------------
    // ǂݍ
    // ----------------------------------------------------------------------
    // ͓{
    sprintf(gFilePath, "%s/%s", MULTI_DIC_PATH, getDicName(curLangId));
    dicNum = makeDict(gFilePath, gDict);
    if (dicNum <= 0) {
        PRINT_OUT("[ERROR]: MakeDict failed.\n") ;
        goto FINISH;
    }
    PRINT_OUT("MakeDic Success\n");

    // ----------------------------------------------------------------------
    // ˑf[^ǂݍ
    // ----------------------------------------------------------------------
    lang = getLangType(curLangId);
    sprintf(gFilePath, "%s/%s/%s", MULTI_DATA_PATH, getLangName(curLangId), "mixed.large" );

    MEMSET( gDataItem,0,sizeof(gDataItem));
    ret = makeLangData(gFilePath, gDataItem);
    if (ret != 0) {
        PRINT_OUT("[ERROR]: MakeLangData failed.\n") ;
        goto FINISH;
    }
    PRINT_OUT("MakeLangData Success\n");

    // ----------------------------------------------------------------------
    // }CN̏
    // ----------------------------------------------------------------------
    CallbackFlag = 0 ;
    ret = ASR_MICInit( gMicBuffer, MicDemo::MIC_BUFFER_SIZE, Callback, &errCode );
    if (ret != ASR_NO_ERROR){
        PRINT_OUT("[ERROR] MIC_Init Error \n");
        goto FINISH;
    }
    
    // }CNgp\ɂȂ܂ő҂
    while (!CallbackFlag){
        /* }CNdOFFԂ̏ꍇA1sɃR[obN֐Ă΂CallBackFlagω */
        PRINT_OUT("Waiting for Mic Init\n");
        nn::os::Thread::Sleep(nn::fnd::TimeSpan::FromMilliSeconds (100));
    }
    // ԂB
    ASR_MICInitConfirm();

    // F
    ret = ASR_MWInit(lang, gDataItem, ASR_DATA_ITEM_NUM, workMem );
    if (ret != ASR_NO_ERROR){
        PRINT_OUT("ASR_MWInit() failed.\n");
        goto FINISH;
    }

    // ----------------------------------------------------------------------
    // C[v
    // ----------------------------------------------------------------------
    while(true)
    {
        // Fs
        {

            /* FJnw */
            CallbackFlag = 0 ;
            GameASRFlag = 0;
            int loop_stop = 0;

            // TODO
            ParamType param;
            ASRResultType  asrResult;


            GetParam(&param);

            ret = ASR_MWRecogStart((unsigned char *)gDict, dicNum, &param, &asrResult, Callback);
            if (ret != ASR_NO_ERROR){
                goto FINISH;
            }

            /* FIR[obN҂[v */
            while (GameASRFlag == 0){

                // x[^[̕\
                graphics.ClearDisplay(NN_GX_DISPLAY1);
                glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
                InitDraw(NN_GX_DISPLAY1_WIDTH, NN_GX_DISPLAY1_HEIGHT);
                graphics.SetColor(NN_GX_DISPLAY1, 1.0, 0.0, 0.0);            
                DrawLevelMeter(&drawer, pDrawStringBuf1, &font, gVoiceVal );
                graphics.SwapBuffer(NN_GX_DISPLAY1);

                // L[
                // ----------------------------------------------------------------------
                // Rg[[̑ɂ郁j[̑
                // ----------------------------------------------------------------------
                // B{^Œ~
                // START{^ŏI
                // ----------------------------------------------------------------------
                padReader.ReadLatest(&padStatus);

                if (padStatus.trigger & BUTTON_B){
                    loop_stop = 1;
                    g_againFlag = true;
                    ASR_MWRecogStop();
                    break;
                }

                // SATRT Button ŏI
                if (padStatus.trigger & BUTTON_START)
                {
                    PRINT_OUT("[Pushed Start Button]\n");
                    loop_stop = 1;
                    g_againFlag = false;
                    ASR_MWRecogStop();
                }

                graphics.WaitVsync();
            }

            // FI
            ASR_MWRecogEnd();
            if (loop_stop){
                break;
            }
            
            /* ̎_ asrResult ɂ͌ʂ܂Ă */
            MEMSET( gRecogWord[0],0, ASR_MAX_CANDIDATES*ASR_MAX_SENTENCE_LENGTH*sizeof(char));
            recogNum=0;
            if (GameASRFlag != ASR_RESULT_RECOG_COMPLETED){
                /* Fs */
                /* GameASRError ̓eɉăG[ */
                sprintf(gRecogWord[0], "Recogintion Failed. \n     [%s(%d)] \n", ASRResultString(asrResult.result), asrResult.result);
                recogNum = 1;
            }else{

                /* Fʂ擾ď */
                /* ł̓fobK̃R\[ɏo͂Ă */
                PRINT_OUT(":\tP \tFXRA\n" ) ;
                for(cnt = 0; cnt< asrResult.result; cnt++) {

                    sprintf(gRecogWord[cnt], "%02d: %s   (%d)\n", cnt+1,getDictWord(asrResult.candiNum[cnt]-1), asrResult.candiScore[cnt]);
                    PRINT_OUT("%02d:\t%s\t (%d)\n", cnt+1,getDictWord(asrResult.candiNum[cnt]-1) , asrResult.candiScore[cnt]);
                }
                recogNum = asrResult.result;
            }
            glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
            InitDraw(NN_GX_DISPLAY0_WIDTH, NN_GX_DISPLAY0_HEIGHT);
            graphics.SetColor(NN_GX_DISPLAY0, 1.0, 1.0, 1.0);            
            DrawTextWithFontLong(&drawer, pDrawStringBuf0, &font, &gRecogWord[0], recogNum, NN_GX_DISPLAY0_WIDTH, NN_GX_DISPLAY0_HEIGHT);

            sprintf(str,"Language = [%s]", getLangName(curLangId));
            DrawText(&drawer, pDrawStringBuf3, &font, str, 15, 200 ,NN_GX_DISPLAY0_WIDTH, NN_GX_DISPLAY0_HEIGHT);
            graphics.SwapBuffer(NN_GX_DISPLAY0);
            nn::os::Thread::Sleep(nn::fnd::TimeSpan::FromMilliSeconds (100));

        }


        // ----------------------------------------------------------------------
        // wait vsync
        // ----------------------------------------------------------------------
        graphics.WaitVsync();
    }


FINISH:

    // MWI
    ret = ASR_MWEnd(NULL);

    /* }CNI */
    (void)ASR_MICEnd();
    
    /* DataItem̔j */
    deleteLangData( gDataItem );

    // tHg̔j
    CleanupFont(&font);

    if( g_againFlag ){
        PRINT_OUT(" GOTO PLAY_AGAIN\n");
        g_againFlag = false;
        // tHg̍\z
        InitFont(&font,L"rom:/font/Latin1.bcfnt"); 
        goto PLAY_AGAIN;
    }


    drawer.Finalize();

    // `惊\[X̔j
    OS_FREE(drawerBuf);


    // `敶pobt@̉
    OS_FREE(pDrawStringBuf0);
    OS_FREE(pDrawStringBuf1);
    OS_FREE(pDrawStringBuf2);
    OS_FREE(pDrawStringBuf3);

    graphics.FinalizeGraphics();


    if( workMem ){
        OS_FREE(workMem);
        workMem=NULL;
    }

    nn::hid::Finalize();

    FILE_IO_TERM();
    OS_MEM_TERM();

    PRINT_OUT("Program END\n");

    return ;
}

