/*-----------------------------------------------------------------------*
 Project: [ASR GuiSample]
 File: [libASRMW.cpp]

 Copyright (C) 2010 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/
/******************************************************************
                    include t@C
*******************************************************************/
#include <nn/os.h>
#include "asr_mw.h"
#include "libASRMW.h"

/******************************************************************
        萔^^`
*******************************************************************/
// Xbh֘A
#define ASR_STACK_SIZE 4096

// R[obN֘A
typedef struct ASR_cb_data {
    ASRCallback cb;
    void     *addr;  // }CNɂ̓X[vԂɂg
} ASRCallbackData;

// F֘A
//#define ASR_FRAME_TIME 40
//#define ASR_FRAME_SIZE 441
#define ASR_HALF_FRAME_WAIT  5460
#define ASR_FULL_FRAME_WAIT 10910

#define MIC_SLEEP_TIME_SHORT  50
#define MIC_SLEEP_TIME_LONG   1000

/******************************************************************
        staticf[^`
*******************************************************************/
// }CNCX^X
static s16 gASR_Flag_MIC_Init = 0;
static void * gASR_MIC_Buffer = NULL;

// GWCX^X
static s16 gASR_Flag_MW_Init = 0;
static s16 gASR_Flag_MW_Recg = 0;

static nn::os::Thread gRecogThread;
static nn::os::Thread gMicThread;

// [vobt@r
//static OSMutex ASR_MW_mutex;

// FXbh̃vCIeB (}CNXbh̓vCIeBŒ)
static u32 gThreadPriority;

// 2005.07.11 FJnʒm邽߂̕ϐ
static u16 gASR_Started_Flag;

static MicDemo gMicObj;

/******************************************************************
        O[oϐQ
*******************************************************************/

/******************************************************************
        O[o֐Q
*******************************************************************/

/******************************************************************
        [J֐vg^Cv
*******************************************************************/
// }CNXbh
static void MicThreadMain( void* aParam );
// }CNTvOAFXbh
static void RecogThreadMain( void* aParam );

/******************************************************************
        O[o֐`
*******************************************************************/
/*!--------------------------------------------------------*
 @brief  : ASR_MICInit()
 @param  : aMic        }CNIuWFNg
 @return :  : ASR_NO_ERROR
         : s : ASR_ERROR_PARAM     :p^G[
         : s : ASR_ERROR_INTERNAL  :G[
 @summary: }CN
*----------------------------------------------------------*/
s16 ASR_MICInit( void* aMicBuffer, int aBufferSize,
          ASRCallback aCallback, s16 *aParam )
{
    ASRCallbackData cbData;
    bool  status;

    // `FbN
    if( aMicBuffer == NULL || aBufferSize < 0 ||
        aCallback  == NULL || aParam == NULL ) {
        return ASR_ERROR_PARAM;
    }
    gASR_MIC_Buffer = aMicBuffer;

    // ~hEFAԂmF
    if(gASR_Flag_MIC_Init) {
        return ASR_ERROR_INTERNAL;
    }
    gASR_Flag_MIC_Init = 1;
    gMicObj.Initialize( aMicBuffer, aBufferSize, &status );

    // Xbh쐬ă}CNTvOƔFJn
    cbData.cb   = aCallback;
    cbData.addr = aParam;

    // dONꍇ
    if( status ){
        *aParam=1;   // 500ms wait 
    }else{
        *aParam=0;   // 50ms wait 
    }

    // XbhJn
    gMicThread.StartUsingAutoStack(MicThreadMain, (void *)(&cbData), ASR_STACK_SIZE, gThreadPriority );
    return ASR_NO_ERROR;
}
/*!--------------------------------------------------------*
 @brief  : ASR_MICInitConfirm()
 @param  : Ȃ
 @return : Ȃ
 @summary: }CNmF
*----------------------------------------------------------*/
void ASR_MICInitConfirm( void )
{
    PRINT_OUT("[MicInit Confirm]\n");
    gMicThread.Join();
    gMicThread.Finalize();
}
/*!--------------------------------------------------------*
 @brief  : ASR_MICEnd()
 @param  : Ȃ
 @return :  : ASR_NO_ERROR
         : s : ASR_ERROR_INTERNAL  :G[
 @summary: }CNI
*----------------------------------------------------------*/
s16 ASR_MICEnd(void)
{
    // Čďõ`FbN
    if(gASR_Flag_MIC_Init!=1) {
        return ASR_ERROR_INTERNAL;
    }

    gMicObj.Finalize();
    gASR_Flag_MIC_Init = 0;
    
    return ASR_NO_ERROR;
}

/*!--------------------------------------------------------*
 @brief  : ASR_MWInit()
 @param  : aLangType      ID
 @param  : aData          ˑf[^ւ̃|C^
 @param  : aItemCount     ˑf[^
 @param  : aMem           [Nւ̃|C^
 @return :  : ASR_NO_ERROR
         : s : ASR_ERROR_PARAM     :p^G[
         : s : ASR_ERROR_INTERNAL  :G[
 @summary: ~hEFA
*----------------------------------------------------------*/
s16 ASR_MWInit( LangType aLangType, DataItemType *aData,
                s16 aItemCount, s16 *aMem)
{
    s16 libRet;

    // `FbN
    if(aLangType < LANG_JAPANESE || aLangType > LANG_MEX_SPANISH ||
        aData == NULL || aItemCount <= 0 || aItemCount > ASR_DATA_ITEM_NUM ||
        aMem == NULL) {
        return ASR_ERROR_PARAM;
    }

    // Čďo`FbN
    if(gASR_Flag_MW_Init) {
        return ASR_ERROR_INTERNAL;
    }
    
    gASR_Flag_MW_Init = 1;

    gThreadPriority = ASR_DEFAULT_THREAD_PRIORITY;
    
    // RAGW
    libRet = RecogInit(aLangType, aData, aItemCount, aMem);
    if( libRet != ASR_NO_ERROR ){
        gASR_Flag_MW_Init = 0;
        return libRet;
    }
    
    return ASR_NO_ERROR;

}

/*!--------------------------------------------------------*
 @brief  : ASR_MWEnd()
 @param  : aData      
 @return :  : ASR_NO_ERROR
         : s : ASR_ERROR_INTERNAL  :G[
 @summary: ~hEFAI
*----------------------------------------------------------*/
s16 ASR_MWEnd(void *aData)
{
    s16 libRet;

    // Čďo`FbN(Fʖ)
    if((!gASR_Flag_MW_Init) || (gASR_Flag_MW_Recg)) {
        return ASR_ERROR_INTERNAL;
    }
    gASR_Flag_MW_Init = 0;

    // RAGWI
    libRet = RecogEnd(aData);

    return libRet;
}

/*!--------------------------------------------------------*
 @brief  : ASR_MWRecogStart()
 @param  : aDict          f[^ւ̃|C^
 @param  : aWordCnt       
 @param  : aParam         p^\̂ւ̃|C^
 @param  : aResult        ʏo͍\̂ւ̃|C^
 @param  : aCallback      R[obN֐ւ̃|C^
 @return :  : ASR_NO_ERROR
         : s : ASR_ERROR_PARAM     :p^G[
         : s : ASR_ERROR_INTERNAL  :G[
 @summary: FJnw
*----------------------------------------------------------*/
s16 ASR_MWRecogStart(u8 *aDict, s16 aWordCnt, ParamType *aParam,
                   ASRResultType *aResult, ASRCallback aCallback)
{
    ASRCallbackData cbData;
    s16 libRet;
    
    // `FbN
    // `FbN ASR_SetDict()ōsB
    if(aResult == NULL || aCallback == NULL) {
        return ASR_ERROR_PARAM;
    }

    // ԁAČďo`FbN
    if((!gASR_Flag_MW_Init) || (gASR_Flag_MW_Recg)) {
        return ASR_ERROR_INTERNAL;
    }

    // Zbg
    libRet = SetDict(aDict, aWordCnt);
    if(libRet != ASR_NO_ERROR) {
        return libRet;
    }
    
    // p[^Zbg
    if( aParam != NULL ){
        libRet = SetParam(aParam);
        if( libRet != ASR_NO_ERROR) {
            return libRet;
        }
    }
    
    // Xbh쐬ă}CNTvOƔFJn
    cbData.cb   = aCallback;
    cbData.addr = (void *)aResult;

    // XbhJn
    gRecogThread.StartUsingAutoStack(RecogThreadMain, (void *)(&cbData), ASR_STACK_SIZE, gThreadPriority );


    return ASR_NO_ERROR;
}

/*!--------------------------------------------------------*
 @brief  : ASR_MWRecogStop()
 @param  : Ȃ
 @return : Ȃ
 @summary: FIw
*----------------------------------------------------------*/
void ASR_MWRecogStop(void)
{
    gASR_Flag_MW_Recg = 0;
}

/*!--------------------------------------------------------*
 @brief  : ASR_MWRecogEnd()
 @param  : Ȃ
 @return : Ȃ
 @summary: FIw
*----------------------------------------------------------*/
void ASR_MWRecogEnd(void)
{
    gRecogThread.Join();
    gRecogThread.Finalize();
    gASR_Flag_MW_Recg = 0;

}

/*!--------------------------------------------------------*
 @brief  : ASR_MWSetThreadPriority()
 @param  : aPrio          vCIeB
 @return : Ȃ
 @summary: FXbh̃vCIeBݒ
*----------------------------------------------------------*/
void ASR_MWSetThreadPriority(u32 aPrio)
{
    // ͈͊O͒AG[ɂȂ
    if(aPrio > 31) {
        gThreadPriority = 31;
    } else {
        gThreadPriority = aPrio;
    }
}

/*!--------------------------------------------------------*
 @brief  : ASR_MWGetThreadPriority()
 @param  : Ȃ
 @return :  : vCIeB(0-31)
 @summary: FXbh̃vCIeB擾
*----------------------------------------------------------*/
u32  ASR_MWGetThreadPriority(void)
{
    return gThreadPriority;
}

/******************************************************************
        [J֐`
*******************************************************************/
/*!--------------------------------------------------------*
 @brief  : MicThreadMain()
 @param  : aParam         p^
 @return :  : ASR_NO_ERROR
         : s : ASR_ERROR_PARAM     :p^G[
         : s : ASR_ERROR_INTERNAL  :G[
 @summary: }CNJn
*----------------------------------------------------------*/
static void MicThreadMain( void* aParam )
{
    ASRCallbackData *cb_data = (ASRCallbackData *)aParam;
    ASRCallback callback = cb_data->cb;
    void *addr = cb_data->addr;
    s64  sleepTime;
    
    if( *(s16 *)addr ){
        sleepTime = (s64)MIC_SLEEP_TIME_LONG;
    }else{
        sleepTime = (s64)MIC_SLEEP_TIME_SHORT;
    }

    // 500 or 50ms ҂
    nn::os::Thread::Sleep(nn::fnd::TimeSpan::FromMilliSeconds(sleepTime));

    // R[obN֐ďo
    *(s16 *)addr = 0;
    callback(ASR_RESULT_MICINIT_COMPLETED, addr);

}
/*!--------------------------------------------------------*
 @brief  : RecogThreadMain()
 @param  : aParam         p^
 @return :  : ASR_NO_ERROR
         : s : ASR_ERROR_PARAM     :p^G[
         : s : ASR_ERROR_INTERNAL  :G[
 @summary: Fs
*----------------------------------------------------------*/
static void RecogThreadMain( void* aParam )
{
    s16 libRet;
    ASRCallbackData *cb_data = (ASRCallbackData *)aParam;
    ASRCallback callback = cb_data->cb;
    ASRResultType *result = (ASRResultType*)cb_data->addr;
    ASRResultCode ret_code;
    gASR_Started_Flag = 0;
    s16*   pFrame=NULL;
    u32    fSize=0;
    int    voiceCount;
    int    voiceMax;

    // Ö׊emF
    if(gASR_MIC_Buffer == NULL) {
        ret_code = ASR_RESULT_RECOG_FAILED;
        result->result = ASR_ERROR_MIC;
        goto asr_exit;
    }

    // r
//    OS_InitMutex(&ASR_MW_mutex);
    
    // }CNTvOJn
    gMicObj.Start();

    // FJn
    libRet = RecogStart();
    if( libRet != ASR_NO_ERROR ) {
        result->result = libRet;
        ret_code = ASR_RESULT_RECOG_FAILED;
        goto asr_exit;
    }
    gASR_Flag_MW_Recg = 1;

    libRet = ASR_NO_ERROR;

    gASR_Started_Flag = 0;
    voiceCount=0;
    voiceMax=0;

    while ( libRet == ASR_NO_ERROR) {
        fSize = 0;
        gMicObj.GetMicData( &pFrame, &fSize);    
        // FIwH
        if( !gASR_Flag_MW_Recg){
            PRINT_OUT("[STOPED]\n");
            libRet = RecogFrame(pFrame, 0);
            break;
        }

        if( fSize > 0 ){
            libRet = RecogFrame(pFrame, fSize);
            if( libRet == ASR_RECOG_STARTED ){
                if( gASR_Started_Flag == 0){
                    // FJnꂽŏ̃^C~Ô݃R[obN
                    gASR_Started_Flag = 1;
                    result->result = 0;
                    callback(ASR_RESULT_RECOG_STARTED, result);
                }
                // FtO ASR_NO_ERROR Ɠ
                libRet = ASR_NO_ERROR;
            }
            //OS_UnlockMutex( &ASR_MW_mutex );

            //FʂH
            if(libRet != ASR_NO_ERROR) {
                break;
            } else {

                 // x[^pf[^쐬
                 if( voiceMax < abs(pFrame[0])){
                     voiceMax = abs(pFrame[0]);
                 }
                 voiceCount++;
                 if (voiceCount == 20) {
                     callback(ASR_RESULT_VOICE_LEVEL, &voiceMax);
                     voiceMax = 0;
                     voiceCount = 0;
                 }

                nn::os::Thread::Sleep(nn::fnd::TimeSpan::FromMicroSeconds(ASR_HALF_FRAME_WAIT));
            }
        } else {
            nn::os::Thread::Sleep(nn::fnd::TimeSpan::FromMicroSeconds(ASR_FULL_FRAME_WAIT));
        }

    }

    // }CNTvOXgbv
    gMicObj.Stop();

    // FIAʊi[
    result->result = libRet;
      
    if(libRet > 0) {
        // FAʊi[
        int cnt;
        for (cnt = 0; cnt < ASR_CANDI_NUM; cnt++) {
            result->candiNum[cnt]   = GetCandidateWord((s16)(cnt+1));
            result->candiScore[cnt] = GetCandidateScore((s16)(cnt+1));
        }

        // 2005.01.20
        if(result->candiNum[0] == -1) {
            result->result = ASR_ERROR_OFFTIMEOUT;
            ret_code = ASR_RESULT_RECOG_FAILED;
        } else {
           // ŃR[obN
           ret_code = ASR_RESULT_RECOG_COMPLETED;
        }
    } else {
        // Fs
        ret_code = ASR_RESULT_RECOG_FAILED;
    }
    
asr_exit:
    callback(ret_code, result);
    gASR_Flag_MW_Recg = 0;
}

