/*-----------------------------------------------------------------------*
 Project: [ASR Sample]
 File: [asr_mic.h]

 Copyright (C) 2010 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/

#ifndef ASR_MIC_H_
#define ASR_MIC_H_

#include <nn/os.h>
#include <nn/types.h>

class MicDemo
{
public:
    virtual void Initialize(void);
    virtual void Finalize(void);

    virtual void Start(void);
    virtual void End(void);

    void GetMicData(s16** pDest, u32 *pSize);
    s16 ReadBuffer( s16 *pFrame );
    void GetMicData(s16* pDest, size_t size);

private:
    static const int MIC_BUFFER_SIZE   = 128*100*60*2; /* 1 */
    static const u8  MIC_GAIN          = 43;
    static const int FRAME_SIZE        = 128;
    
    size_t m_SamplingLength;
    u8 m_MicGain;
    NN_PADDING3;
    s16* ASR_ReadStart;
    int  m_micLoop;
    uptr m_lastSampAddress;
    nn::os::Mutex m_mutex;
    static char m_MicBuffer[MIC_BUFFER_SIZE];
};

#endif /* #ifndef ASR_MIC_H_ */

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
