#ifndef _CTR_DEFINE_H_
#define _CTR_DEFINE_H_


#define ENABLE_TIMESCALE 


#include "CTR_Memory.h"
#include "CTR_Fio.h"
#ifdef ENABLE_TIMESCALE 
#include "CTR_Tick.h"
#ifdef TIME_SET_USEC
#define TIME_UNIT "usec"
#else
#define TIME_UNIT "msec"
#endif /* #ifdef TIME_SET_USEC */
#endif /* #ifdef ENABLE_TIMESCALE  */
#include "CTR_Utility.h"

/* n */
#define OS_MEM_INIT   CTR_MEM_Init
#define OS_MEM_TERM   CTR_MEM_Term
#define OS_MALLOC_EX  CTR_MEM_MallocEx
#define OS_MALLOC32   CTR_MEM_Malloc32
#define OS_MALLOC     CTR_MEM_Malloc
#define OS_FREE       CTR_MEM_Free
#define OS_GET_FREEHEAPSIZE CTR_MEM_GetFreeSizeOfHeap
#define MEMSET        CTR_MEMSET
#define MEMSET32      CTR_MEMSET
#define MEMCPY        CTR_MEMCPY
#define MEMCPY32      CTR_MEMCPY
#define MEMCMP        CTR_MEMCMP


/* t@Cn */
#define FILE_IO_INIT        CTR_FIO_FileInit
#define FILE_IO_TERM        CTR_FIO_FileTerm
#define FILE_OPEN           CTR_FIO_FileOpen
#define FILE_CLOSE          CTR_FIO_FileClose
#define FILE_GETSIZE        CTR_FIO_GetFileSize

#define FILE_GETFILENAMES   CTR_FIO_GetFileNames

#define FILE_READ           CTR_FIO_FileRead
#define FILE_WRITE          CTR_FIO_FileWrite
#define FILE_FGETS          CTR_FIO_FGets
#define FILE_SEEK           CTR_FIO_FSeek

/* o͌n */
#define PRINT_OUT2          NN_LOG
#define PRINT_OUT           NN_LOG

/* n */
#define STRCPY(a,b)         std::strcpy( (char*)a, (const char*)b )
#define STRNCPY(a,b,c)      std::strncpy( (char*)a, (const char*)b, (size_t)n )
#define STRCMP(a,b)         std::strcmp( (const char*)a, (const char*)b )
#define STRNCMP(a,b,c)      std::strncmp( (const char*)a, (const char*) b, (size_t)c )
#define STRLEN(a)           std::strlen( (const char*)a )
#define STRTOK(a,b)         std::strtok( (char*)a, (const char*)b )

/* Ԍvn */
#ifdef ENABLE_TIMESCALE
typedef unsigned long       OS_TICK;
#endif /* #ifdef ENABLE_TIMESCALE */
#define OS_TICK_INIT        CTR_TickInit
#define OS_GET_TICK         CTR_GetTick
#define OS_TICKS_TO_MSEC(x) (x)

/* [eBeBn */
#define GET_KEY_EVENT       CTR_GetKeyEvent
#define UTILITY_INIT        CTR_UtilityInit
#define UTILITY_TERM        CTR_UtilityTrem

/*******************************************************************
  
*******************************************************************/
/* ̑ */
#define D_MATH_ROUNDUP32(x)        (x)
#define D_MATH_ROUNDUP(x,align)    (x)


#endif /* #ifndef _CTR_DEFINE_H_ */
