#ifndef _CTR_FILEIO_H_
#define _CTR_FILEIO_H_

#include <nn.h>
#include <stdio.h> // FILE

#define MAX_FILE_NAME_LEN  128
typedef struct {
	char name[MAX_FILE_NAME_LEN];
} textfile;

#define D_FILE_IO_ALIGNMENT   4

#ifndef SEEK_SET
#define SEEK_SET 0
#endif /* #ifndef SEEK_SET */

#ifndef SEEK_CUR
#define SEEK_CUR 1
#endif /* #ifndef SEEK_CUR */

#ifndef SEEK_END
#define SEEK_END 2
#endif /* #ifndef SEEK_END */

#define D_MAX_FILE_NUM        16 /* ɊJt@C̍ő吔     */
#define D_MAX_FOLDER_NUM      16 /* ɊJfBNg̍ő吔 */

#define D_ROMFS_BUFFER_SIZE   1024*64 // 20*1636920 ?

#ifdef __cplusplus
extern "C" {
#endif
/* ֐` */
void          CTR_FIO_FileInit( void );
void          CTR_FIO_FileTerm( void );
FILE          *CTR_FIO_FileOpen(const char *path, const char *mode);
FILE          *CTR_FIO_FileOpen2(const wchar_t *path, const char *mode);
int           CTR_FIO_FileClose( void *stream );
unsigned long CTR_FIO_GetFileSize( void *stream );
long          CTR_FIO_FileRead( void* ptr, unsigned long elsize, unsigned long elcnt, void *stream );
long          CTR_FIO_FileWrite( void* ptr, unsigned long elsize, unsigned long elcnt, void *stream );
char          *CTR_FIO_FGets(char *buf, int len, void *stream);
int           CTR_FIO_FSeek( void *stream, long offset, int dir );
int           CTR_FIO_GetFileNames( void* fp, textfile *file);

#ifdef __cplusplus
}
#endif

#endif /* #ifndef _CTR_FILEIO_H_ */

