/*-----------------------------------------------------------------------*
 Project: [Common]
 File: [CTR_Fio.cpp]

 Copyright (C) 2009 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/

/**
 *    CTRł FileStreamNX t@C I/O ĂB
 *    ̂߁AWC/C++ƂI/F{t@CŋzB
 *    {I APII/F͕WC/C++stdxxx ƓƂB
 */
/******************************************************************
                        include t@C
*******************************************************************/
#include "CTR_Fio.h"
#include <nn/fs.h>
#include <string.h> // str***
#include <stdlib.h> // mbstowcs
#include "CTR_Define.h" // memset

using namespace nn::fs;

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************
            萔^^`
*******************************************************************/
/** őFile I/O  */
#define MAX_DSC_NUM 10

/******************************************************************
            static 錾
*******************************************************************/
/* FileStream */
static FileStream gStream[MAX_DSC_NUM];
/* ǂݍłTCY(FileStream) */
static s32 gFgetReadedSize[MAX_DSC_NUM];

/* gpĂ FileStream */
static int gDscCnt = 0;

/* rom A[JCu̓Ɏgp郁̈ */
static char gRomMem[D_ROMFS_BUFFER_SIZE];

/******************************************************************
            OJ֐
*******************************************************************/
/*!--------------------------------------------------------*
 @brief  : CTR_FIO_FileInit()
 @param  : Ȃ
 @return : Ȃ
 @summary: t@CVXȅ
 @note   : O nn::fs::Initilizse()sĂ邱
*----------------------------------------------------------*/
void CTR_FIO_FileInit()
{
    nn::Result  result;
    gDscCnt = 0;

    result = MountRom(
                  D_MAX_FILE_NUM,        // ɊJt@C̍ő吔
                  D_MAX_FOLDER_NUM,      // ɊJfBNg̍ő吔
                  gRomMem,               // A[JCu̓Ɏgp郁̈̐擪AhX 
                  D_ROMFS_BUFFER_SIZE    // A[JCu̓Ɏgp郁̈̃TCY 
             );

    NN_UTIL_PANIC_IF_FAILED(result);

    return;
}

/*!--------------------------------------------------------*
 @brief  : CTR_FIO_FileTerm()
 @param  : Ȃ
 @return : Ȃ
 @summary: Ȃ
 @note   : ̊֐Ă΂鎞_ŁAgDscCnt0̂͂
         : 0łȂꍇ́ACloseYꂠB
*----------------------------------------------------------*/
void CTR_FIO_FileTerm( void )
{
    if( gDscCnt != 0 ){
        NN_LOG("[ERROR] DscCnt != 0\n");
    }
    return;
}
/*!--------------------------------------------------------*
 @brief  : CTR_FIO_FileOpen()
 @param  : path  I[vt@C(pX܂)
 @param  : mode  I[v[h 
 @return : t@C 
 @summary: t@CI[ṽt@Cւ̃AhX
           ԂB
*----------------------------------------------------------*/
FILE *CTR_FIO_FileOpen(const char *path, const char *mode)
{
    FILE  *file=NULL;
    nn::Result  result;
    wchar_t wPath[256];
    wchar_t wBuf[256];
    int     len=0;
    bit32   openMode;


    MEMSET( wPath,0,sizeof(wPath)/sizeof(wPath[0]));
    MEMSET( wBuf,0,sizeof(wBuf)/sizeof(wBuf[0]));

    if( path == NULL ){
        NN_LOG( "[Error] path = NULL \n");
        return NULL;
    }

    if( strncmp(mode,"w",1) == 0 ){
        openMode = OPEN_MODE_WRITE|OPEN_MODE_CREATE;
    }else{
        openMode = OPEN_MODE_READ;
    }

    if( gDscCnt >= MAX_DSC_NUM -1 ){
        NN_LOG("[Error] Max DSC num \n" );
        return NULL;
    }    

    if( path == NULL ){
        NN_LOG("[Error] path is NULL \n" );
        return NULL;
    }

    len=strlen( path );

    // char -> wchar_t
    mbstowcs( wPath, path, len );

    result = gStream[gDscCnt].TryInitialize( wPath, openMode );
    if( result.IsFailure()){
        NN_LOG("File Open Error (%ls %08x)", wPath, result.GetPrintableBits());
        return NULL;
    }else{
    }
    // fgetsp̃[hTCY̏
    gFgetReadedSize[gDscCnt]=0;

    // vbgtH[I/F킹邽߃_~[
    file = (FILE*)&gStream[gDscCnt];
    gDscCnt++;

    return file;
}
/*!--------------------------------------------------------*
 @brief  : CTR_FIO_FileClose()
 @param  : stream  N[Yt@CXg[
 @return :  0
           s EOF
 @summary: I[vς݃t@C
*----------------------------------------------------------*/
int CTR_FIO_FileClose( void *stream )
{
    int i=0;
    FileStream  *local = (FileStream*)stream;
    for( i=0;i< MAX_DSC_NUM;i++){
        if( &gStream[i] == local ){
            local->Finalize();
            gFgetReadedSize[gDscCnt-1]=0;
            gDscCnt--;
            break;
        }
    }
    return 0;
}



/*!--------------------------------------------------------*
 @brief  : CTR_FIO_GetFileSize()
 @param  : stream  TCY擾t@CXg[
 @return : t@CTCY
 @summary: I[vς݃t@C̃t@CTCY擾
*----------------------------------------------------------*/
unsigned long CTR_FIO_GetFileSize( void *stream )
{
    u32 size=0;
    FileStream  *local = (FileStream*)stream;

    size = (u32)local->GetSize();
    return (unsigned long)size;
}


/*!--------------------------------------------------------*
 @brief  : CTR_FIO_FileRead()
 @param  : ptr     ǂݍݐobt@
 @param  : elsize  vf1̑傫
 @param  : elcnt   vf
 @param  : stream  ̓t@CXg[
 @return : ǂݍ񂾃TCYivfj
 @summary: I[vς݃t@CwTCYǂݍ
*----------------------------------------------------------*/
long CTR_FIO_FileRead( void* ptr, unsigned long elsize, unsigned long elcnt, void *stream )
{
    s32 read_size=-1;
    long ret;
    FileStream  *local = (FileStream*)stream;

    read_size = local->Read( ptr, (size_t)( elsize*elcnt ) );
    if( read_size < 0 ){
        return -1;
    }

    ret = (long)(read_size/elsize);
    return ret;
}

/*!--------------------------------------------------------*
 @brief  : CTR_FIO_FileWrite()
 @param  : ptr     ݐobt@
 @param  : elsize  vf1̑傫
 @param  : elcnt   vf
 @param  : stream  o̓t@CXg[
 @return : 񂾃TCYivfj
 @summary: I[vς݃t@C֎wTCYǂݍ
*----------------------------------------------------------*/
long CTR_FIO_FileWrite( void* ptr, unsigned long elsize, unsigned long elcnt, void *stream )
{
    s32 write_size=-1;
    long ret;

    FileStream  *local = (FileStream*)stream;

    write_size = local->Write( ptr, (size_t)( elsize*elcnt ), true );
    if( write_size < 0 ){
        return -1;
    }
    ret = (long)(write_size/elsize);

    return ret;
}


/*!--------------------------------------------------------*
 @brief  : CTR_FIO_FGets()
 @param  : buf     obt@̈ւ̃|C^
 @param  : len     obt@TCY
 @param  : stream  t@CXg[
 @return : ǂݍ݃obt@ւ̃|C^
 @summary: fgets()̑
*----------------------------------------------------------*/
char *CTR_FIO_FGets(char *buf, int len, void *stream)
{
    s32 ret=0;
    int i;
    u32 work_size = 0;
    FileStream  *local = (FileStream*)stream;

    work_size = (u32)local->GetSize();
    if( gFgetReadedSize[gDscCnt-1] >= work_size ){
        gFgetReadedSize[gDscCnt-1] = 0;
        return NULL;
    }
    
    if( (work_size - gFgetReadedSize[gDscCnt-1] ) < len ){
        len = (work_size - gFgetReadedSize[gDscCnt-1] ) + 1;
    }


    for( i=0;i< MAX_DSC_NUM;i++){
        if( &gStream[i] == local ){
            break;
        }
    }
    if( i==MAX_DSC_NUM ) return NULL;

    ret = local->Read( buf, len );
    if (ret <= 0){ 
        /* t@C̏I[̏ꍇNULLԂ */
        return NULL;
    } else {
        for (i = 0; i < ret; i++) {
            if( buf[i]=='\n' ) {
                ++i;
                break;
            } 
        }
        buf[i] = '\0';
        gFgetReadedSize[gDscCnt-1] +=i;

        // Ȃ Seek(0)͎s
        if( (i-ret) < 0 ){
            (void)local->Seek( (s64)(i - ret), POSITION_BASE_CURRENT );
        }

    }

    return buf;

}

/*!--------------------------------------------------------*
 @brief  : CTR_FIO_FSeek()
 @param  : stream  t@CXg[
 @param  : offset  V[NItZbg
 @param  : dir     V[N
 @return :  0: 
 @return : -1: s
 @summary:
*----------------------------------------------------------*/
int CTR_FIO_FSeek( void *stream, long offset, int dir )
{
    PositionBase base;
    FileStream  *local = (FileStream*)stream;

    if( dir == SEEK_SET ){
        base = POSITION_BASE_BEGIN;
    } else if( dir == SEEK_END ){
        base = POSITION_BASE_END;
    }else{ // SEEK_CUR
        base = POSITION_BASE_CURRENT;
    }

    local->Seek( (s64)offset, base );

    return 0;
}

/*!--------------------------------------------------------*
 @brief  : CTR_FIO_GetFileNames()
 @param  : stream  t@CXg[
 @param  : file    i[\
 @return : ǂݍ񂾃t@C̐
 @summary: wt@CXg[̃t@Ctextfile\̂Ɋi[
*----------------------------------------------------------*/
int CTR_FIO_GetFileNames( void* stream, textfile *file)
{
    NN_UNUSED_VAR(stream)
    NN_UNUSED_VAR(file)

    return 0;
}

#ifdef __cplusplus
}
#endif



